/* Medium Level TDC V1190 Driver - Original driver from JFC@IPN-CNRS for the V767 - MG xx/xx/2005 @ LIXAM-CNRS*/

#include "tdc1190_driver_low.h"

/*===================================================== DEFINES =================================================== */
#define NO_TDC_ERROR               0
#define TDC_ERROR                  0x0A<<16

#define MICRO_MAX_OPERAND          42
/* =============================================================================================================== */
/* STRUCTURES */
typedef struct {
  unsigned int command;
  char object;
  char nW;
  char nR;
  unsigned int nbit;
  unsigned int operand[MICRO_MAX_OPERAND];
} opcode;

/* ================================================================================================================ */
/* EXTERNAL PROTOTYPES */
int write_register(vme_access *tdc_access, int reg, unsigned int data);
int read_register(vme_access *tdc_access, int reg, unsigned int *data);
/*-----------------------------*/
int status_micro(vme_access *tdc_access, unsigned int *status );
int write_micro(vme_access *tdc_access, opcode *op);
int read_micro(vme_access *tdc_access, opcode *op);
/*-----------------------------*/
int read_status(vme_access *tdc_access, unsigned int *status);

int read_output(vme_access *tdc_access, unsigned int *out);
int read_DMAoutput(vme_access *tdc_access, unsigned int *out);
void print_output(unsigned int *out);
